#pragma once

//Copyright (C) cocosimulator.org 2014
//generated by AmsterCHEM's COM CAPE-OPEN Wizard

//Window pre-processor definitions
#ifndef UNICODE
#define UNICODE
#endif //UNICODE
#ifndef _UNICODE
#define _UNICODE
#endif //_UNICODE
#ifndef _WIN32
#define _WIN32
#endif //_WIN32

//external includes
using namespace std;
#include <string>
#include <vector>
#include <stdio.h>
#include <windows.h>

//ASSERT macro definition
// usage ASSERT(bool condition,const char *additionalInformation)
#ifndef _DEBUG
#ifdef DEBUG
#define _DEBUG
#endif //DEBUG
#endif //_DEBUG
#ifdef _DEBUG
//define for breaking asserts; comment out for TRACE asserts only
#define _BREAKONASSERTS
#ifdef _BREAKONASSERTS
  //an ASSERT that shows a message box that allows breaking
  #define ASSERT(condition,description) \
  {if (!(condition)) \
    {char *buf; \
     buf=new char[1024]; \
	 if (buf) \
	  {const char *desc=description; \
       sprintf_s(buf,1024,"%s (%d): assert failed\r\n%s\r\n",__FILE__,__LINE__,desc); \
       if (MessageBoxA(GetActiveWindow(),buf,"ASSERT:",MB_ICONHAND|MB_OKCANCEL)==IDCANCEL) __debugbreak(); \
       delete []buf; \
	  }\
	 else if (MessageBoxA(GetActiveWindow(),"Out of memory","ASSERT:",MB_ICONHAND|MB_OKCANCEL)==IDCANCEL) __debugbreak(); \
    } \
  };
#else 
  //just put a line in the trace window
  #define ASSERT(condition,description) \
  {if (!(condition)) \
    {char *buf; \
     buf=new char[1024]; \
	 if (buf) \
	  {const char *desc=description; \
       sprintf_s(buf,1024,"ASSERT FAILURE: %s (%d): %s\r\n",__FILE__,__LINE__,desc); \
       OutputDebugStringA(buf); \
       delete []buf; \
	  }\
	 else OutputDebugStringA("ASSERT FAILURE: Out of memory"); \
    } \
  };
#endif //_BREAKONASSERTS
#else
 #define ASSERT(condition,description) ;
#endif //DEBUG

// Globals
extern LONG ModuleLockCount; //access to this variable must be thread safe
extern HINSTANCE myInstanceHandle;

//definition of missing numbers.
// we set outgoing missing numbers to CapeDoubleMissingValue
// incoming missing numbers can be checked using isMissing
#include <limits>
#include <float.h>
#include <math.h>
//the definition as in a deprecated document, but might still be used:
#define OldCapeDoubleEmpty -DBL_MAX
//the new definition is IEEE NaN
extern const double CapeDoubleMissingValue; 
//this we will use to check for missing values:
#ifndef _MSC_VER
#ifndef _isnan
#define _isnan isnan
#endif
#endif
inline bool isMissing(double d) {
	return (d==OldCapeDoubleEmpty)||(_isnan(d));
}

//project includes
#include "Lock.h"
#include "stringConversions.h"
#include "StringMap.h"
#include "cape-open.h"
#include "errors.h"
#include "BStr.h" 
#include "Variant.h" 
#include "COMSmartPtr.h"
#include "COMObject.h"

// GUID definitions for this project

//{8D3663F4-EE76-4201-A38E-4849ABB54300}
DEFINE_GUID(CLSID_WaterServer,0x8D3663F4,0xEE76,0x4201,0xA3,0x8E,0x48,0x49,0xAB,0xB5,0x43,0x00);
//{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}
DEFINE_GUID(CLSID_WaterPackage,0x3ABCC2E6,0x3E2A,0x43C6,0xB6,0x07,0xA3,0xBE,0x7F,0x0C,0xA4,0x82);
/*GUID_INSERT_LOCATION*/


#ifndef WINAPICALL
#ifdef _MSC_VER
//use this definition + def file in MS compilers
#define WINAPICALL(type) extern "C" type  __stdcall
#else
//use this definition for use without .def file
#define WINAPICALL(type) extern "C" __declspec( dllexport ) type  __stdcall
#endif //_MSC_VER
#endif //WINAPICALL

#ifdef __GNUC__
//MS takes buffer size as the second argument, so does _swnprintf
#define swprintf _snwprintf
//__FUNCTIONW_ macro
#define __FUNCTIONW__ MultibyteToUnicode(__func__)
//_wfopen_s
__inline int _wfopen_s(FILE **f,const wchar_t *filename,const wchar_t *mode) {*f=_wfopen(filename,mode);if (!f) return errno;return 0;}
#endif

//definition of missing numbers.
// we set outgoing missing numbers to CapeDoubleMissingValue
// incoming missing numbers can be checked using isMissing
#include <limits>
#include <float.h>
//the definition as in a deprecated document, but might still be used:
#define OldCapeDoubleEmpty -DBL_MAX
//the new definition is IEEE NaN
extern const double CapeDoubleMissingValue; 
//this we will use to check for missing values:
#ifndef _MSC_VER
#ifndef _isnan
#define _isnan isnan
#endif
#endif


